/*Змінні*/

volatile int intResultDif;              // Дані з АЦП
volatile boolean bolTact = false;       // Повний цикл (360 градусів, 4 вимірювання)
int interruptCtr = 0;                   // Кількість переривань, половина циклу - 2 (зміна рівня для генерації меандру)

// Робота з масивами

byte intSs = 0;                         // Номер строки масиву
byte intCs = 0;                         // Номер колонки масиву

int sensorValues[3][4];                 // Ініціалізація масиву на 4 стовпці * 3 рядки
int intMiddle[4];                       // Ініціалізація масиву на 4 значення медіанного фільтру
//int intXY[3][2];                      // Ініціалізація масиву на 2 стовпці (X, Y) * 3 рядки (в планах фільт Х та У, окрім їх складових

// змінні для медіанного фільтру 3
int intA;
int intB;
int intC;

//Розрахунок фази
int intS = -2;                                            // лічильник сумування Х та У, починаємо з -2 щоб пропустити стартові порожні значення
long lngSX;                                               // сума даних по X
long lngSY;                                               // сума даних по Y

void setup()
{
  Serial.begin(115200);
  PIOB->PIO_OER = 1 << 25;                                 // Встановлюємо 2 контакт Arduino DUE як вихід
  adc_setup();
  tc_setup();
}
void loop()
{
  if (bolTact)                                             // якщо пройшов повний цикл (360 градусів)
  {
    bolTact = false;
    lngSX = intMiddle[0] - intMiddle[2] + lngSX;          // розрахунок Х та фільтрація за допомогою простого середнього на 512 значень (без ділення)
    lngSY = intMiddle[3] - intMiddle[1] + lngSY;          // розрахунок У та фільтрація за допомогою простого середнього на 512 значень (без ділення)

    if (intS++ >= 511)
    {
      //Serial.println(lngSY / 2048.00000 * 3300 / 4096); // виведення сигналу "У" на монітор, використовується для встановлення в "0" початкової фази
      //Serial.println(lngSX /2048.00000 * 3300 / 4096);  // виведення сигналу "У" на монітор
      Serial.println(90.00000 * lngSY / (lngSY + lngSX)); // розрахунок фази
      // обнуляємо змінні
      intS = 0;
      lngSX = 0;
      lngSY = 0;
    }
  }
}

/*************  Configure ADC function  *******************/
void adc_setup() {

  PMC->PMC_PCER1 |= PMC_PCER1_PID37;                      // ADC power on
  ADC->ADC_CR = ADC_CR_SWRST;                             // Reset ADC

  ADC->ADC_MR |=  ADC_MR_TRGEN_EN |                       // Hardware trigger select / Вибрати апаратний тригер
                  ADC_MR_TRGSEL_ADC_TRIG1 |               // Тригер TIOA0 - висхідний край (по фронту)
                  ADC_MR_LOWRES_BITS_12 |                 // 0 - BITS_12 - 12-bit resolution, 1 - BITS_10 - 10-bit resolution
                  ADC_MR_SLEEP_NORMAL |                   // Режим сну: 0 - NORMAL, 1 - SLEEP
                  ADC_MR_PRESCAL(3) |                     // ADCClock = MCK / ( (PRESCAL+1) * 2 )
                  ADC_MR_STARTUP_SUT0 |                   // 0 periods of ADCClock
                  ADC_MR_SETTLING_AST9 |                  // Analog Settling Time
                  ADC_MR_ANACH_ALLOWED |                  // Analog Change, Дозволяє використовувати різні аналогові налаштування для кожного каналу
                  ADC_MR_TRACKTIM(10) |                   // Tracking Time = (TRACKTIM + 1) * ADCClock periods.
                  ADC_MR_TRANSFER(2) |                    // Transfer Period = (TRANSFER * 2 + 3) ADCClock periods.
                  ADC_MR_USEQ_NUM_ORDER;                  // Use Sequence Enable, Нормальний режим: Контролер перетворює канали в простій цифровій послідовності.

  //Differential mode for channels 7 and 6 (6 - 7); Gain = 0.5
  //AD7 will be automatically enabled for differential operation
  ADC->ADC_COR = ADC_COR_DIFF6 |
                 ADC_COR_OFF6;

  //ADC->ADC_ACR = ADC_ACR_IBCTL(0b01);                   // Only if 1 MHz > conversion frequency > 500 KHz
  ADC->ADC_IER = ADC_IER_EOC6;
  ADC->ADC_CGR = 0x15555555;                              // Gain = 1, HEX 15555555 = BIN  00010101010101010101010101010101
  NVIC_EnableIRQ(ADC_IRQn);
  ADC->ADC_CHER |= ADC_CHER_CH6 | ADC_CHER_CH7;           // Enable Channels 7,6 = A0,A1
}
/*************  Timer Counter 0 Channel 0 to generate PWM pulses thru TIOA0  ************/
void tc_setup() {

  PMC->PMC_PCER0 |= PMC_PCER0_PID27;                       // Timer Counter 0 channel 0 IS TC0 / Лічильник таймера 0 канал 0 IS TC0

  TC0->TC_CHANNEL[0].TC_CMR = TC_CMR_TCCLKS_TIMER_CLOCK1   // MCK/2, clk on rising edge
                              | TC_CMR_WAVE                // Waveform mode
                              | TC_CMR_WAVSEL_UP_RC        // UP mode with automatic trigger on RC Compare
                              | TC_CMR_ACPA_CLEAR          // Clear TIOA0 on RA compare match
                              | TC_CMR_ACPC_SET;           // Set TIOA0 on RC compare match

  TC0->TC_CHANNEL[0].TC_RC = 524;                           // Frequency = (Mck/2)/TC_RC/2 = 20038Hz
  TC0->TC_CHANNEL[0].TC_RA = 262;                           // Duty cycle / робочий цикл = (TC_RA/TC_RC) * 100  % ???

  TC0->TC_CHANNEL[0].TC_CCR = TC_CCR_SWTRG | TC_CCR_CLKEN;  // Reset TC0 counter and enable
}

/*************  Обробка переривань  ************/
void ADC_Handler(void)
{
  intResultDif = ADC->ADC_CDR[6];                           // отримання даних з АЦП
  sensorValues[intSs][intCs] = intResultDif;                // внесення даних в двомірний масив

  //Формування меандру
  if ( interruptCtr++ >= 1 )                                // кожне 2 переривання - переключаємо рівень виходу (меандр)
  {
    interruptCtr = 0;                                       // обнуляємо лічильник переривань
    REG_PIOB_ODSR ^= 1 << 25;                               //переключити рівень 2 PWM виходу (формуємо меандр для Тх)
  }
  if (intCs == 2) bolTact = true;                           // завершення періоду, "дозвіл" на обробку даних
  if (intCs++ >= 3)                                         // два значення Х та 2 значення У
  {
    intCs = 0;
    if (intSs++ >= 2)                                       // 3 строчки для медіанного фільтру
    {
      intSs = 0;
    }
  }

  // Дані для фільтру пікового шуму (медіанний фільтр на 3 значення)

  intA = sensorValues[0][intCs];
  intB = sensorValues[1][intCs];
  intC = sensorValues[2][intCs];

  // Медіанний фільтр (фільтр пікового шуму)
  /* https://embeddedgurus.com/stack-overflow/tag/median-filter/ */
  /*Проводимо перше сортування за спаданням:if (A<B) and (A<C),
    то вважаємо A – найменшим елементом і далі вибираємо між B і С,
    найменший елемент є медіаною і видаємо його на вихід*/
  if ((intA <= intB) && (intA <= intC))
  {
    intMiddle[intCs] = (intB <= intC) ? intB : intC;
  }
  /*Якщо умова при першому сортуванні не виконується,
    тоді проводимо друге сортування за спаданням: if (B<A) and (B<C),
    тоді вважаємо B – найменшим елементом і далі вибираємо між A і С,
    найменший елемент є медіаною і видаємо його на вихід*/
  else if ((intB <= intA) && (intB <= intC))
  {
    intMiddle[intCs] = (intA <= intC) ? intA : intC;
  }
  /*Якщо умови по першому і другому сортуванню не виконуються,
    тоді проводимо третє сортування за спаданням між  A і B,
    найменший елемент є медіаною і видаємо його на вихід*/
  else
  {
    intMiddle[intCs] = (intA <= intB) ? intA : intB;
  }
}
